<?php
class CacheFile
{
    private $file;
    private $during;
    private $data;
    private $time;
    private $flag;
    public function __construct($pathfile,$during=30)
	{
//        echo "PATH $pathfile\n";
        $this->flag="";
        $this->file = $pathfile;
        $this->time = -1;
        $this->during = $during;
        if(file_exists($this->file))
        {
            $fp = fopen($this->file, "r");
            if($fp)
            {
                if (flock($fp, LOCK_SH)) 
                { 
                    $json =  fread($fp, filesize($this->file));
                    $json = json_decode($json);
                    $this->data = $json->data;
                    $this->time = $json->time;
                    $this->during  = $json->during;
                    flock($fp, LOCK_UN);    // Enlève le verrou
                } 
                else 
                {
                    $this->flag  = 'Can\'t lock file';
                }
                fclose($fp);
            }
            else
            {
                $this->flag  = 'Can\'t open file';
            }
        }
    }
    public function isValid()
    {
        if(!empty($this->flag))
        {
            return false;
        }
        $now = new DateTime();
        $now = $now->getTimestamp();
        $timestamp = $this->time + ($this->during*60);
        if($this->time == -1)
        {
            return false;
        }
        elseif( $timestamp <= $now)
        {
            return false;
        }
        else
        {
            return true;
        }
    }
    public function getData()
    {
        return $this->data;
    }
    public function setData()
    {
        $timestamp = new DateTime();
        $this->data = $data;
        $this->time = $timestamp->getTimestamp();
    }
    public function writeData($data,$time=-1)
    {
        $timestamp = new DateTime();
        $this->data = $data;
        if($time==-1)
        {
            $this->time = $timestamp->getTimestamp();
            $during =$this->during;
        }
        else
        {
            $this->time=$time;
            $during =0;
        }
        $json = array('time'=> $this->time,'during'=>$during, 'data'=> $data);
        $json = json_encode($json);
        if(empty($this->flag))
        {
            $fp = fopen($this->file, "w+");
            if($fp)
            {
                if (flock($fp, LOCK_EX)) 
                { 
                        $result =  fwrite($fp,$json);
                        flock($fp, LOCK_UN);    // Enlève le verrou
                        if($result ===FALSE)
                        {
                  //          echo "Impossible d'écrire dans le fichier !";
                        }
                } 
                else 
                {
                //    echo "Impossible de verrouiller le fichier !";
                }
                fclose($fp);
            }
            else
            {
               // echo "Erreur d'ouverture";
            }
        }
    }
}


?>
