package GesaProtocol;
use warnings;
use strict;
use Carp;
use Text::CSV;

use vars qw($VERSION);
$VERSION = '1.00';

sub new(){
	my ( $cl, $max, $eol, $sep_char ) =@_;
	my $csv = Text::CSV->new ( { binary => 1 } )  # should set binary attribute.
                 or die "Cannot use CSV: ".Text::CSV->error_diag ();
	
	$eol=$eol||"\r\n";	
	$csv->eol($eol);
	$csv->sep_char($sep_char||",");
#	$csv->escape_char("\\");
	$csv->allow_whitespace(1);
	$csv->always_quote(1);
#	$csv->allow_loose_escapes(1);

	my $end="<END>$eol";
	my $more="<MORE>$eol";
	$max=$max||4000;

	my $lend=length($end);
	my $lmore=length($more);
	my $limit=$max-(( $lend < $lmore) ? $lmore : $lend ) ;	

	my $this = {
		"_CSV" 		=> $csv,
		"_OUTPUT"	=> [$end],
		"_MAXCHARS"	=> $max,
		"_NCHARS"	=> 0,
		"_END"		=> $end,
		"_MORE"		=> $more,
		"_LCHARS"	=> $limit,
	};
	
	bless($this,$cl);
	return $this;
}

sub addLine(){
	my ($this)=shift;
	$this->{_CSV}->combine(@_);
	#my $this = \%hash;	
	my $line=$this->{_CSV}->string();
	my $l=length($line);
	
	if( ($this->{_NCHARS} + $l) > $this->{_LCHARS})
	{
		#my $tmp = @{ $this->{_OUTPUT} };
		pop( @{ $this->{_OUTPUT} } );
		push(@{ $this->{_OUTPUT} }, $this->{_MORE});
		#push($this->{_OUTPUT},$this->{_MORE});
		return 1; 
	}
	else {
                pop( @{ $this->{_OUTPUT} } );
		push(@{ $this->{_OUTPUT} }, $line);
		push(@{ $this->{_OUTPUT} },$this->{_END});
#		pop($this->{_OUTPUT});
 #               push($this->{_OUTPUT},$line);
#		push($this->{_OUTPUT},$this->{_END});
		$this->{_NCHARS}+=length($line);
		return 0;
	}
}

sub size(){
	my ($this)=shift;
	return $this->{_NCHARS};
}

sub output(){
        my ($this)=shift;
	return $this->{_OUTPUT};
} 

sub print(){
	my ($this)=shift;
	while( my $element = shift(@{ $this->{_OUTPUT} })){
        	print($element);
	}
}

1;
