# --- fichier PLUGIN.pm ---
package ESIA::PLUGIN;
use strict;
use warnings;
use POSIX qw(floor);
our $TIMEOUT = 50;
our %ERRORS=('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3,'DEPENDENT'=>4);
our @priorities=(
                $ERRORS{CRITICAL},
                $ERRORS{WARNING},
                $ERRORS{UNKNOWN},
                $ERRORS{OK});
sub priority_state
{
    my($a,$b) = @_;
    if( $a == $b )
    {
         #pas besoin d'aller dans la boucles si ils sont identiques
        return $a; 
    }
    foreach my $v (@ESIA::PLUGIN::priorities)
    {
        if ( $v == $a || $v == $b )
        {
            return $v;
        }
    }
}
sub arm_end_signal
{
    my($a) = @_;
    $SIG{'ALRM'} = sub {
	    print ("ERROR: Plugin took too long to complete (alarm)\n");
	    exit $ERRORS{"UNKNOWN"};
    };
    alarm($a);
}
sub print_header
{
    my $progname = $_[0];
    my $progdescr= $_[1];
	print "Copyright (c) 2019 Esia SA\n";
	print "\n";
	print "$progname\n";
    print '=' x length($progname);
	print "\n";
    if($progdescr)
    {
        print "Description:\n";
	    print "     $progdescr\n";
        print '=' x length($progname);
	    print "\n";
    }
}
sub print_help
{
    my $used = $_[0];
    my $othervar =  $_[1];
    if($othervar)
    {
        foreach my $key ( @$othervar) 
        {
            if($key eq 'V')
            {
                push(@$used,["-V","--version","plugin version"]);
            }
            elsif($key eq 'h')
            {
                push(@$used,["-h","--help","print this help"]);
            }
        }
    }
    print "Plugin parameters: \n";
    printf ("     %-10s%-20s%s\n", 'short','long','description:');
    foreach my $key ( @$used) 
    {
        my @line = @$key; 
        printf ("     %-10s%-20s%s\n", $line[0],$line[1],$line[2]);
    }
}
1;
