#!/usr/bin/php
<?php
$dir = dirname($argv[0]);
define('PLUGINS_DIR',"$dir/plugins");
define('PATTERNS_DIR',"$dir/patterns");

/*
$_SERVER['DOCUMENT_ROOT']='/usr/local/public_html';
include_once '/usr/local/esia/public_html/esia.conf.php';
*/
$content_file = file_get_contents('/root/.pgpass');
$content_array = explode("\n",$content_file);
foreach($content_array as $line){
        $uncomment = explode('#',$line);
        $db_params = explode(':',$uncomment[0]);
        if( count($db_params) == 5 ) break;
}

define('DB_HOST',$db_params[0]);
define('DB_PORT',5432);
define('DB_NAME',$db_params[2]);
define('DB_USERNAME',$db_params[3]);
define('DB_PWD',$db_params[4]);

function execute_query($dbconnection,$sql){
	$query = $dbconnection->prepare($sql);
	$ret = $query->execute();

	if( $ret === false ){
		$err = $query->errorInfo();
		echo $err[2]."\n";
		return FALSE;
	}
	return $query->fetchAll(PDO::FETCH_ASSOC);
}

$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

function read_file($path){
	$content = explode("\n",file_get_contents($path));	
	$ret = array();
	$j=-1;
	for($i=0;$i<count($content);$i++){
		$row = $content[$i];
		if( !empty(trim($row)) ) { 	
			if( preg_match('/--(\w+):(\S*)/',$row,$matches) ){
				$ret[$matches[1]] = $matches[2];
			}
			elseif ( preg_match('/\s*(INSERT|UPDATE|DELETE)\s*/',$row) ){
				$j++;
				$ret['sql'][$j] = $row;				
			}
			else {
				$ret['sql'][$j].=$row;	
			}
		}
	}
	return $ret;
}

function execute_requests($requests){
	global $dbconnection;
	$dbconnection->beginTransaction();
	$ret = true;
	foreach($requests as $request){
		if(!$dbconnection->exec($request)){
			$ret = false;
			break;
		}
	}
	if( $ret ) return $dbconnection->commit();
	else $dbconnection->rollBack();

	return $ret;
}

$options = getopt('t:');
if( empty($options['t'] ) ) $type = 'base';
else $type = $options['t'];

$type = strtolower(trim($type));
$type = explode(',',$type);

$db_plugins = execute_query($dbconnection,"SELECT * FROM esia_plugins");
$db_plugins_names = array_column($db_plugins,'plugin_name');

$plugins_files = scandir(PLUGINS_DIR);
foreach($plugins_files as $file){
	$path = PLUGINS_DIR."/$file";

	if(is_file($path)){
		$data_plugin=read_file($path);
		if( in_array(strtolower($data_plugin['INFRA']),$type)){
			if(!in_array($data_plugin['NAME'],$db_plugins_names)){
				if(execute_requests($data_plugin['sql']) != false ){
					echo "ADDED plugin ".$data_plugin['NAME']."\n";
				}
				else  echo "ERROR plugin ".$data_plugin['NAME']."\n";
			}
			else echo "FOUND plugin ".$data_plugin['NAME']."\n";
		}
	}
}

$db_patterns = execute_query($dbconnection,"SELECT * FROM esia_service_patterns");
$db_patterns_names = array_column($db_patterns,'pattern_name');

$patterns_files = scandir(PATTERNS_DIR);
foreach($patterns_files as $file){
	$path = PATTERNS_DIR."/$file";

	if(is_file($path)){
		$data_pattern=read_file($path);
		if( in_array(strtolower($data_pattern['INFRA']),$type)){
			if(!in_array($data_pattern['NAME'],$db_patterns_names)){
				if(execute_requests($data_pattern['sql']) != false ){
					echo "ADDED pattern ".$data_pattern['NAME']."\n";
				}
				else  echo "ERROR pattern ".$data_pattern['NAME']."\n";
			}
			else echo "FOUND pattern ".$data_pattern['NAME']."\n";
		}
	}
}
?>
